searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `KafkaMskAuth`.","ref":"KafkaMskAuth.html","title":"KafkaMskAuth","type":"module"},{"doc":"","ref":"KafkaMskAuth.html#adapt_auth_config/1","title":"KafkaMskAuth.adapt_auth_config/1","type":"function"},{"doc":"","ref":"KafkaMskAuth.html#region/0","title":"KafkaMskAuth.region/0","type":"function"},{"doc":"KafkaProtocolLib module is a facade behavior/implementation for Erlang's Kafka Protocl library modules\nRef: https://github.com/kafka4beam/kafka_protocol\nContains wrapper functions for methods in kpro, kpro_lib and kpro_req_lib modules\nPurpose: Creating this as a behavior helps us mock the network calls made during authentication exchanges","ref":"KafkaMskAuth.KafkaProtocolLib.html","title":"KafkaMskAuth.KafkaProtocolLib","type":"behaviour"},{"doc":"","ref":"KafkaMskAuth.KafkaProtocolLib.html#find/2","title":"KafkaMskAuth.KafkaProtocolLib.find/2","type":"function"},{"doc":"","ref":"KafkaMskAuth.KafkaProtocolLib.html#c:find/2","title":"KafkaMskAuth.KafkaProtocolLib.find/2","type":"callback"},{"doc":"","ref":"KafkaMskAuth.KafkaProtocolLib.html#make/3","title":"KafkaMskAuth.KafkaProtocolLib.make/3","type":"function"},{"doc":"","ref":"KafkaMskAuth.KafkaProtocolLib.html#c:make/3","title":"KafkaMskAuth.KafkaProtocolLib.make/3","type":"callback"},{"doc":"","ref":"KafkaMskAuth.KafkaProtocolLib.html#send_and_recv/5","title":"KafkaMskAuth.KafkaProtocolLib.send_and_recv/5","type":"function"},{"doc":"","ref":"KafkaMskAuth.KafkaProtocolLib.html#c:send_and_recv/5","title":"KafkaMskAuth.KafkaProtocolLib.send_and_recv/5","type":"callback"},{"doc":"SASL AWS_MSK_IAM auth backend implementation for brod Erlang library.\nTo authenticate, supply aws_secret_key_id and aws_secret_access_key with access to MSK cluster","ref":"KafkaMskAuth.MskIamAuth.html","title":"KafkaMskAuth.MskIamAuth","type":"module"},{"doc":"AwsSignatureLib module is a facade behavior/implementation for Erlang's aws_signature module\nRef: https://github.com/kafka4beam/kafka_protocol\nContains wrapper functions for methods in aws_signature module\nPurpose: Creating this as a behavior helps us mock the payload building and signing calls made","ref":"KafkaMskAuth.SignedPayloadGenerator.html","title":"KafkaMskAuth.SignedPayloadGenerator","type":"behaviour"},{"doc":"Builds AWS4 signed AWS_MSK_IAM payload needed for making SASL authentication request with broker\n# Reference: https://github.com/aws-beam/aws_signature\n\nReturns signed payload in bytes","ref":"KafkaMskAuth.SignedPayloadGenerator.html#get_signed_payload/4","title":"KafkaMskAuth.SignedPayloadGenerator.get_signed_payload/4","type":"function"},{"doc":"","ref":"KafkaMskAuth.SignedPayloadGenerator.html#c:get_signed_payload/4","title":"KafkaMskAuth.SignedPayloadGenerator.get_signed_payload/4","type":"callback"},{"doc":"# KafkaMskAuth\n\n`kafka_msk_auth` is an authentication plugin for `brod` and `broadway_kafka`. It enables Broadway Kafka clients to authenticate with Amazon's Managed Streaming for Apache Kafka(Amazon MSK) via [AWS_MSK_IAM](https://docs.aws.amazon.com/msk/latest/developerguide/iam-access-control.html) SASL mechanism as well as [OAuthBearer](https://docs.confluent.io/platform/current/security/authentication/sasl/oauthbearer/overview.html).\n\nThis code is heavily based upon [`ex_aws_msk_iam_auth`](https://github.com/BigThinkcode/ex_aws_msk_iam_auth/) but was extended to support the OAUTHBEARER auth mechanism as well as role based auth.","ref":"readme.html","title":"KafkaMskAuth","type":"extras"},{"doc":"Add the following dependency to your `mix.exs`\n```elixir\ndef deps do\n  [\n    {:kafka_msk_auth, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - KafkaMskAuth","type":"extras"},{"doc":"Broadway Kafka supports connecting to Kafka broker via SASL authentication. The following sample configuration shows how `kafka_msk_auth` plugin can be used with it.\n \nRef: https://hexdocs.pm/broadway_kafka/BroadwayKafka.Producer.html#module-client-config-options\n\n```elixir\n  client_config: [\n            sasl:\n              {\n                :callback, \n                KafkaMskAuth.MskIamAuth, \n                {:MSK_IAM_AUTH, %{access_key_id: \"AWS_ACCESS_KEY_ID\", secret_access_key: \"AWS_SECRET_ACCESS_KEY\"}}\n              },\n            ssl: true\n          ]\n```","ref":"readme.html#usage","title":"Usage - KafkaMskAuth","type":"extras"},{"doc":"","ref":"readme.html#background","title":"Background - KafkaMskAuth","type":"extras"},{"doc":"[Broadway Kafka](https://github.com/dashbitco/broadway_kafka) is a Kafka Connector for [Broadway](https://github.com/dashbitco/broadway) - an Elixir library to build concurrent, multi-stage data ingestion/processing pipelines with Elixir.\nBroadway Kafka is an amalgamation of awesome features from Broadway with Kafka as a producer. Internally, it uses [brod](https://github.com/kafka4beam/brod) as its Kafka client acting as a wrapper. Brod supports `SASL PLAIN`, `SCRAM-SHA-256` and `SCRAM-SHA-512` authentication mechanisms out of the box and also offers extension points to support custom [authentication plugins](https://github.com/kafka4beam/brod#authentication-support).","ref":"readme.html#broadway-kafka-and-brod","title":"Broadway Kafka and brod - KafkaMskAuth","type":"extras"},{"doc":"MSK supports two variants - MSK Fully Managed and MSK Serverless. In both the variants, Kafka service can be protected via SASL, in particular, AWS's custom SASL mechanism AWS_MSK_IAM(https://docs.aws.amazon.com/msk/latest/developerguide/iam-access-control.html). At the time of writing this library, MSK's Serverless variant's only supported authentication was AWS_MSK_IAM SASL mechanism.","ref":"readme.html#aws-msk-authentication-mechanisms","title":"AWS MSK Authentication Mechanisms - KafkaMskAuth","type":"extras"},{"doc":"![Solution Diagram](solution.png)","ref":"readme.html#solution-diagram","title":"Solution Diagram - KafkaMskAuth","type":"extras"},{"doc":"This library takes inspiration from its Java counterpart [aws-msk-iam-auth](https://github.com/aws/aws-msk-iam-auth)","ref":"readme.html#implementation","title":"Implementation - KafkaMskAuth","type":"extras"},{"doc":"1. https://github.com/dashbitco/broadway_kafka/issues/82\n2. https://github.com/dashbitco/broadway_kafka/pull/85\n3. https://github.com/aws-beam/aws_signature/issues/14","ref":"readme.html#relevant-issues-prs","title":"Relevant Issues/PRs - KafkaMskAuth","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}